package org.rcisoft.business.buildtp.controller;


/*固定导入*/

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.business.buildtp.entity.BuildTp;
import org.rcisoft.business.buildtp.service.BuildTpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
*
 * @author
 * @date 2018-4-3 10:11:34
 */
@RestController
@RequestMapping("buildtp")
public class BuildTpController extends PaginationController<BuildTp> {

    @Autowired
    private BuildTpService buildTpServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(@Valid BuildTp buildTp, BindingResult bindingResult) {
        buildTp.setToken(getToken());
        PersistModel data = buildTpServiceImpl.save(buildTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        buildTp);
    }

    @ApiOperation(value="逻辑删除", notes="逻辑删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
    @DeleteMapping("/delete/{id:\\w+}")
    public Result delete(@PathVariable String id) {
        BuildTp buildTp = new BuildTp();
        buildTp.setBusinessId(id);
        buildTp.setToken(getToken());
        PersistModel data = buildTpServiceImpl.remove(buildTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        id);
    }

    @ApiOperation(value="修改", notes="修改")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{id:\\w+}")
    public Result update(@Valid BuildTp buildTp, BindingResult bindingResult) {
        buildTp.setToken(getToken());
        PersistModel data = buildTpServiceImpl.merge(buildTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        buildTp);
    }

    @ApiOperation(value="查看单 ", notes="查看单 ")
    @GetMapping("/detail/{id:\\w+}")
    public Result detail(@PathVariable String id) {
        return Result.builder(new PersistModel(1),
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        buildTpServiceImpl.findById(id));
    }

    @ApiOperation(value="查看  集合", notes="查看  集合")
    @GetMapping(value = "/queryBuildTpByPagination")
    public GridModel listByPagination(BuildTp buildTp) {
        buildTpServiceImpl.findAllByPagination(getPaginationUtility(), buildTp);
        return getGridModelResponse();
    }
}
