package org.rcisoft.config;

import org.quartz.Scheduler;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.quartz.SchedulerFactoryBean;

import static com.sun.tools.doclint.Entity.ge;

/**
 * Created by lcy on 18/1/11.
 */

@Configuration
public class QuartzConfig {

    /**
     * attention:
     * Details：定义quartz调度工厂
     */
    @Bean(name = "schedulerFactory")
    public SchedulerFactoryBean schedulerFactory() {
        SchedulerFactoryBean bean = new SchedulerFactoryBean();
        // 用于quartz集群,QuartzScheduler 启动时更新己存在的Job
        bean.setOverwriteExistingJobs(true);
        // 延时启动，应用启动1秒后
        bean.setStartupDelay(1);
        // 注册触发器
        //bean.setTriggers(cronJobTrigger);
        return bean;
    }


    @Bean(name = "scheduler")
    public Scheduler schedulerFactory(SchedulerFactoryBean bean) {
        return bean.getScheduler();
    }






}