package org.rcisoft.core.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.util.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.Date;

/**
 * Created by lcy on 18/2/24.
 *
 * common
 */
@Controller("/common")
public class CommonController<T> extends FileController<T> {

    @Autowired
    private Global global;


    /**
     * 文件上传
     * @param file
     * @return
     */
    @ApiOperation(value="文件上传", notes="文件上传")
    @ApiImplicitParams({@ApiImplicitParam(name = "file", value = "文件", required = true, dataType = "file")})
    @PostMapping(value = "/upload")
    public Result commonFileUpload(@RequestParam("file") MultipartFile file){
        String filePath = super.globalCommonFileUpload(file, super.SAVING_PATTERN_UUID, global.getBaseUploadLocation() +
                global.getTEMP_LOCATION() + File.separator + DateUtil.getSimepleDate("yyyyMMdd", new Date()));
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                filePath);
    }
}
