package org.rcisoft.core.controller;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.UUID;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/28
 * Time: 下午3:28
 * description:  文件操作
 */
@Controller
public class FileController<T> extends PaginationController<T> {
    protected static final SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
    protected static final String SEPARATOR;
    /*date 格式*/
    protected static final String SAVING_PATTERN_DATE = "DATE";
    /*uuid 格式*/
    protected static final String SAVING_PATTERN_UUID = "UUID";

    Logger logger = Logger.getLogger(FileController.class);

    static {
        SEPARATOR = File.separator;
    }



    /**
     * gload 文件上传
     * @param multipartFile
     * @param savingPatternOrFullName
     * @param savingAbsolutePath
     * @return
     */
    protected String globalCommonFileUpload(MultipartFile multipartFile, String savingPatternOrFullName, String savingAbsolutePath) {
        String finalSavingPath;
        String returnFinalFileName;
        label32: {
            String fileExtendsName = "." + getSuffix(multipartFile.getOriginalFilename());
            finalSavingPath = "";
            savingPatternOrFullName = savingPatternOrFullName.toUpperCase();
            returnFinalFileName = "";
            switch(savingPatternOrFullName.hashCode()) {
                case 2090926:
                    if(savingPatternOrFullName.equals(this.SAVING_PATTERN_DATE)) {
                        returnFinalFileName = getCurrentDateTimeString() + fileExtendsName;
                        finalSavingPath = savingAbsolutePath + SEPARATOR + getCurrentDateTimeString() + fileExtendsName;
                        break label32;
                    }
                    break;
                case 2616251:
                    if(savingPatternOrFullName.equals(this.SAVING_PATTERN_UUID)) {
                        returnFinalFileName = getUUIDString() + fileExtendsName;
                        finalSavingPath = savingAbsolutePath + SEPARATOR + getUUIDString() + fileExtendsName;
                        break label32;
                    }
            }

            finalSavingPath = savingAbsolutePath + SEPARATOR + returnFinalFileName;
        }

        File dir = new File(savingAbsolutePath);
        if(!dir.exists()) {
            dir.mkdirs();
        }
        File file = new File(finalSavingPath);
        try {
            if(!file.exists()) {
                file.createNewFile();
            }
            multipartFile.transferTo(file);
        } catch (IllegalStateException var10) {
            var10.printStackTrace();
        } catch (IOException var11) {
            var11.printStackTrace();
        }

        return finalSavingPath;
    }



    public static String getSuffix(String filename) {
        String suffix = "";
        int pos = filename.lastIndexOf(46);
        if(pos > 0 && pos < filename.length() - 1) {
            suffix = filename.substring(pos + 1);
        }

        return suffix;
    }


    protected static String getUUIDString() {
        return UUID.randomUUID().toString().replaceAll("-", "").toUpperCase();
    }

    protected static String getCurrentDateTimeString() {
        return simpleDateFormat.format(new Date());
    }

}
