package org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.exception.ServiceException;
import javax.validation.Valid;


import org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.entity.${table.entityName};
import org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.service.${table.entityName}Service;

import java.util.List;

/**
* Created by ${author} on ${.now}.
*/
@RestController
@RequestMapping("${table.entityName?lower_case}")
public class ${table.entityName}Controller extends PaginationController<${table.entityName}> {

    @Autowired
    private ${table.entityName}Service ${table.entityName?uncap_first}ServiceImpl;


    @ApiOperation(value="添加${table.tableRemark!}", notes="添加${table.tableRemark!}")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(@Valid ${table.entityName} ${table.entityName?uncap_first}, BindingResult bindingResult) {
        ${table.entityName?uncap_first}.setToken(getToken());
        PersistModel data = ${table.entityName?uncap_first}ServiceImpl.save(${table.entityName?uncap_first});
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }

    @ApiOperation(value="逻辑删除${table.tableRemark!}", notes="逻辑删除${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
    @DeleteMapping("/delete/{id:\\w+}")
    public Result delete(@PathVariable String id) {
        ${table.entityName} ${table.entityName?uncap_first} = new ${table.entityName}();
        ${table.entityName?uncap_first}.setBusinessId(id);
        ${table.entityName?uncap_first}.setToken(getToken());
        PersistModel data = ${table.entityName?uncap_first}ServiceImpl.remove(${table.entityName?uncap_first});
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        id);
    }

    @ApiOperation(value="修改${table.tableRemark!}", notes="修改${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{id:\\w+}")
    public Result update(@Valid ${table.entityName} ${table.entityName?uncap_first}, BindingResult bindingResult) {
        ${table.entityName?uncap_first}.setToken(getToken());
        PersistModel data = ${table.entityName?uncap_first}ServiceImpl.merge(${table.entityName?uncap_first});
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }

    @ApiOperation(value="查看单 ${table.tableRemark!}", notes="查看单 ${table.tableRemark!}")
    @GetMapping("/detail/{id:\\w+}")
    public Result detail(@PathVariable String id) {
        return Result.builder(new PersistModel(1),
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first}ServiceImpl.findById(id));
    }

    @ApiOperation(value="查看 ${table.tableRemark!} 集合", notes="查看 ${table.tableRemark!} 集合")
    @GetMapping(value = "/query${table.entityName}ByPagination")
    public GridModel listByPagination(${table.entityName} ${table.entityName?uncap_first}) {
        ${table.entityName?uncap_first}.setCreateBy(UserUtil.getUserInfoProp(getToken(),UserUtil.USER_ID));
        ${table.entityName?uncap_first}ServiceImpl.findAllByPagination(getPaginationUtility(), ${table.entityName?uncap_first});
        return getGridModelResponse();
    }
}
