package org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.service.impl;

import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.dao.${table.entityName}Repository;
import org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.entity.${table.entityName};
import org.rcisoft.org.rcisoft.business.${table.entityName?lower_case}.service.${table.entityName}Service;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by ${author} on ${.now}.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class ${table.entityName}ServiceImpl implements ${table.entityName}Service {

    @Autowired
    private ${table.entityName}Repository ${table.entityName?uncap_first}Repository;


    /**
    * 保存 ${table.entityName?uncap_first}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(${table.entityName} ${table.entityName?uncap_first}){
        //增加操作
        UserUtil.setCurrentPersistOperation(${table.entityName?uncap_first});
        int line = ${table.entityName?uncap_first}Repository.insertSelective(${table.entityName?uncap_first});
        log.info(UserUtil.getUserInfoProp(${table.entityName?uncap_first}.getToken(),UserUtil.USER_USERNAME)+"新增了ID为"+
            ${table.entityName?uncap_first}.getBusinessId()+"的信息");
        return new PersistModel(line);
    }

    /**
    * 逻辑删除
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel remove(${table.entityName} ${table.entityName?uncap_first}){
        UserUtil.setCurrentMergeOperation(${table.entityName?uncap_first});
        ${table.entityName?uncap_first}.setDeleted();
        int line = ${table.entityName?uncap_first}Repository.logicalDelete(${table.entityName?uncap_first});
        log.info(UserUtil.getUserInfoProp(${table.entityName?uncap_first}.getToken(),UserUtil.USER_USERNAME)+"逻辑删除了ID为"+
        ${table.entityName?uncap_first}.getBusinessId()+"的信息");
        return new PersistModel(line);
    }

    /**
    * 修改 ${table.entityName?uncap_first}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel merge(${table.entityName} ${table.entityName?uncap_first}){
        UserUtil.setCurrentMergeOperation(${table.entityName?uncap_first});
        int line = ${table.entityName?uncap_first}Repository.updateByPrimaryKeySelective(${table.entityName?uncap_first});
        log.info(UserUtil.getUserInfoProp(${table.entityName?uncap_first}.getToken(),UserUtil.USER_USERNAME)+"修改了ID为"+
            ${table.entityName?uncap_first}.getBusinessId()+"的信息");
        return new PersistModel(line);
    }

    /**
    * 根据id查询 ${table.entityName?uncap_first}
    * @param id
    * @return
    */
    public ${table.entityName} findById(String id){
        return ${table.entityName?uncap_first}Repository.selectByPrimaryKey(id);
    }

    /**
    * 分页查询 ${table.entityName?uncap_first}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    public List<${table.entityName}> findAllByPagination(PageUtil<${table.entityName}> paginationUtility,
        ${table.entityName} ${table.entityName?uncap_first}){
        ${table.entityName?uncap_first}.setStart();
        ${table.entityName?uncap_first}.setNotDeleted();
        return ${table.entityName?uncap_first}Repository.query${table.entityName}s(${table.entityName?uncap_first});
    }

}
